#  fibonacci.py - 2 approaches
#
import sys, time

ncalls = 0
known = {}

def fibonacci_1 (n) :
    global ncalls
    ncalls += 1
    if n < 2 : return n
    else : return fibonacci_1(n-1) + fibonacci_1(n-2)
    
def fibonacci_2 (n) :
    global ncalls
    ncalls += 1
    ans =  known.get(n,None)
    if ans : return ans
    if n < 2 : return n
    else : 
        ans = fibonacci_2(n-2) + fibonacci_2(n-1)
        known[n] = ans
    return ans

def test() :
    global ncalls
    limit = int(sys.argv[1])

    ncalls = 0
    start = time.time()
    print("fibonacci_1")
    for i in range(1,limit+1) :
        print(" %3d: %5d" % (i, fibonacci_1(i)))
    msec = (time.time() - start)*1000
    print("Fibonacci-1: calls: %s - %f ms" % (ncalls,msec))

    ncalls = 0
    print("\nfibonacci_2")
    start = time.time()
    for i in range(1,limit+1) :
        print(" %3d: %5d" % (i, fibonacci_2(i)))
    msec = (time.time() - start)*1000
    print("Fibonacci-2: calls: %s - %f ms" % (ncalls,msec))

if __name__ == "__main__" : test()

