import sys, random

profits = [-3, 0, -2, 0, 7, 1, 10, 2, -12, 0, -9, 4, -4, 10, 2] #3-7
nsections = len(profits)

def makePromises(trail) :
    promises = [0]*nsections     # create array of same length
    last = len(trail)-1       # last section
    promises[last] = trail[last]  # ending value
    for i in range(last-1, 0, -1) :
        promises[i] = max(profits[i], profits[i]+promises[i+1])
    return promises

def findSeq(promises) :
    best = max(promises)
    for start in range(nsections) :
        if promises[start] == best : break

    end = start; accum=profits[start]
    while accum < best :
        end += 1
        accum += profits[end]
    return start, end, best

def test() :
    promises = makePromises(profits)
    start, end, best = findSeq(promises)
    print(" ".join(["%4d" % x for x in profits]))
    print(" ".join(["%4d" % x for x in promises]))
    print("from %d to %d yields %d" % (start,end,best))

if __name__ == "__main__" : test()

